Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 1 | #!/bin/sh |
Greg Kroah-Hartman | b244131 | 2017-11-01 15:07:57 +0100 | [diff] [blame] | 2 | # SPDX-License-Identifier: GPL-2.0 |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 3 | # |
| 4 | # link vmlinux |
| 5 | # |
Masahiro Yamada | d151e97 | 2019-01-17 09:10:04 +0900 | [diff] [blame] | 6 | # vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and |
| 7 | # $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories |
| 8 | # in the kernel tree, others are specified in arch/$(ARCH)/Makefile. |
| 9 | # $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally |
| 10 | # (not within --whole-archive), and do not require symbol indexes added. |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 11 | # |
| 12 | # vmlinux |
| 13 | # ^ |
| 14 | # | |
Masahiro Yamada | d151e97 | 2019-01-17 09:10:04 +0900 | [diff] [blame] | 15 | # +--< $(KBUILD_VMLINUX_OBJS) |
| 16 | # | +--< init/built-in.a drivers/built-in.a mm/built-in.a + more |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 17 | # | |
Nicholas Piggin | 3a166fc | 2017-06-20 01:52:05 +1000 | [diff] [blame] | 18 | # +--< $(KBUILD_VMLINUX_LIBS) |
| 19 | # | +--< lib/lib.a + more |
| 20 | # | |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 21 | # +-< ${kallsymso} (see description in KALLSYMS section) |
| 22 | # |
| 23 | # vmlinux version (uname -v) cannot be updated during normal |
| 24 | # descending-into-subdirs phase since we do not yet know if we need to |
| 25 | # update vmlinux. |
| 26 | # Therefore this step is delayed until just before final link of vmlinux. |
| 27 | # |
| 28 | # System.map is generated to document addresses of all kernel symbols |
| 29 | |
| 30 | # Error out on error |
| 31 | set -e |
| 32 | |
Masahiro Yamada | 3ec8a5b | 2020-07-02 04:29:36 +0900 | [diff] [blame] | 33 | LD="$1" |
| 34 | KBUILD_LDFLAGS="$2" |
| 35 | LDFLAGS_vmlinux="$3" |
| 36 | |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 37 | # Nice output in kbuild format |
| 38 | # Will be supressed by "make -s" |
| 39 | info() |
| 40 | { |
| 41 | if [ "${quiet}" != "silent_" ]; then |
Andrii Nakryiko | e83b9f5 | 2019-04-02 09:49:50 -0700 | [diff] [blame] | 42 | printf " %-7s %s\n" "${1}" "${2}" |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 43 | fi |
| 44 | } |
| 45 | |
Sami Tolvanen | a8cccdd | 2020-12-11 10:46:24 -0800 | [diff] [blame] | 46 | # Generate a linker script to ensure correct ordering of initcalls. |
| 47 | gen_initcalls() |
| 48 | { |
| 49 | info GEN .tmp_initcalls.lds |
| 50 | |
| 51 | ${PYTHON} ${srctree}/scripts/jobserver-exec \ |
| 52 | ${PERL} ${srctree}/scripts/generate_initcall_order.pl \ |
| 53 | ${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS} \ |
| 54 | > .tmp_initcalls.lds |
| 55 | } |
| 56 | |
Sami Tolvanen | 38e8918 | 2020-12-11 10:46:20 -0800 | [diff] [blame] | 57 | # If CONFIG_LTO_CLANG is selected, collect generated symbol versions into |
| 58 | # .tmp_symversions.lds |
| 59 | gen_symversions() |
| 60 | { |
| 61 | info GEN .tmp_symversions.lds |
| 62 | rm -f .tmp_symversions.lds |
| 63 | |
| 64 | for o in ${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS}; do |
| 65 | if [ -f ${o}.symversions ]; then |
| 66 | cat ${o}.symversions >> .tmp_symversions.lds |
| 67 | fi |
| 68 | done |
| 69 | } |
| 70 | |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 71 | # Link of vmlinux.o used for section mismatch analysis |
| 72 | # ${1} output file |
| 73 | modpost_link() |
| 74 | { |
Stephen Rothwell | a5967db | 2016-08-24 22:29:19 +1000 | [diff] [blame] | 75 | local objects |
Sami Tolvanen | 38e8918 | 2020-12-11 10:46:20 -0800 | [diff] [blame] | 76 | local lds="" |
Stephen Rothwell | a5967db | 2016-08-24 22:29:19 +1000 | [diff] [blame] | 77 | |
Nicholas Piggin | 6358d6e | 2018-02-11 00:25:03 +1000 | [diff] [blame] | 78 | objects="--whole-archive \ |
Masahiro Yamada | d151e97 | 2019-01-17 09:10:04 +0900 | [diff] [blame] | 79 | ${KBUILD_VMLINUX_OBJS} \ |
Nicholas Piggin | 6358d6e | 2018-02-11 00:25:03 +1000 | [diff] [blame] | 80 | --no-whole-archive \ |
| 81 | --start-group \ |
| 82 | ${KBUILD_VMLINUX_LIBS} \ |
| 83 | --end-group" |
| 84 | |
Sami Tolvanen | dc5723b | 2020-12-11 10:46:19 -0800 | [diff] [blame] | 85 | if [ -n "${CONFIG_LTO_CLANG}" ]; then |
Sami Tolvanen | a8cccdd | 2020-12-11 10:46:24 -0800 | [diff] [blame] | 86 | gen_initcalls |
| 87 | lds="-T .tmp_initcalls.lds" |
| 88 | |
Sami Tolvanen | 38e8918 | 2020-12-11 10:46:20 -0800 | [diff] [blame] | 89 | if [ -n "${CONFIG_MODVERSIONS}" ]; then |
| 90 | gen_symversions |
| 91 | lds="${lds} -T .tmp_symversions.lds" |
| 92 | fi |
| 93 | |
Sami Tolvanen | dc5723b | 2020-12-11 10:46:19 -0800 | [diff] [blame] | 94 | # This might take a while, so indicate that we're doing |
| 95 | # an LTO link |
| 96 | info LTO ${1} |
| 97 | else |
| 98 | info LD ${1} |
| 99 | fi |
| 100 | |
Sami Tolvanen | 38e8918 | 2020-12-11 10:46:20 -0800 | [diff] [blame] | 101 | ${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${lds} ${objects} |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 102 | } |
| 103 | |
Peter Zijlstra | 6804c1a | 2020-03-18 13:33:54 +0100 | [diff] [blame] | 104 | objtool_link() |
| 105 | { |
Sami Tolvanen | b1a1a1a | 2020-04-13 16:10:13 -0700 | [diff] [blame] | 106 | local objtoolcmd; |
Peter Zijlstra | 6804c1a | 2020-03-18 13:33:54 +0100 | [diff] [blame] | 107 | local objtoolopt; |
| 108 | |
Sami Tolvanen | b1a1a1a | 2020-04-13 16:10:13 -0700 | [diff] [blame] | 109 | if [ "${CONFIG_LTO_CLANG} ${CONFIG_STACK_VALIDATION}" = "y y" ]; then |
| 110 | # Don't perform vmlinux validation unless explicitly requested, |
| 111 | # but run objtool on vmlinux.o now that we have an object file. |
| 112 | if [ -n "${CONFIG_UNWINDER_ORC}" ]; then |
| 113 | objtoolcmd="orc generate" |
| 114 | fi |
| 115 | |
| 116 | objtoolopt="${objtoolopt} --duplicate" |
| 117 | |
| 118 | if [ -n "${CONFIG_FTRACE_MCOUNT_USE_OBJTOOL}" ]; then |
| 119 | objtoolopt="${objtoolopt} --mcount" |
| 120 | fi |
| 121 | fi |
| 122 | |
Peter Zijlstra | 6804c1a | 2020-03-18 13:33:54 +0100 | [diff] [blame] | 123 | if [ -n "${CONFIG_VMLINUX_VALIDATION}" ]; then |
Sami Tolvanen | b1a1a1a | 2020-04-13 16:10:13 -0700 | [diff] [blame] | 124 | objtoolopt="${objtoolopt} --noinstr" |
| 125 | fi |
| 126 | |
| 127 | if [ -n "${objtoolopt}" ]; then |
| 128 | if [ -z "${objtoolcmd}" ]; then |
| 129 | objtoolcmd="check" |
| 130 | fi |
| 131 | objtoolopt="${objtoolopt} --vmlinux" |
Peter Zijlstra | 6804c1a | 2020-03-18 13:33:54 +0100 | [diff] [blame] | 132 | if [ -z "${CONFIG_FRAME_POINTER}" ]; then |
| 133 | objtoolopt="${objtoolopt} --no-fp" |
| 134 | fi |
Sami Tolvanen | b1a1a1a | 2020-04-13 16:10:13 -0700 | [diff] [blame] | 135 | if [ -n "${CONFIG_GCOV_KERNEL}" ] || [ -n "${CONFIG_LTO_CLANG}" ]; then |
Peter Zijlstra | 6804c1a | 2020-03-18 13:33:54 +0100 | [diff] [blame] | 136 | objtoolopt="${objtoolopt} --no-unreachable" |
| 137 | fi |
| 138 | if [ -n "${CONFIG_RETPOLINE}" ]; then |
| 139 | objtoolopt="${objtoolopt} --retpoline" |
| 140 | fi |
| 141 | if [ -n "${CONFIG_X86_SMAP}" ]; then |
| 142 | objtoolopt="${objtoolopt} --uaccess" |
| 143 | fi |
| 144 | info OBJTOOL ${1} |
Sami Tolvanen | b1a1a1a | 2020-04-13 16:10:13 -0700 | [diff] [blame] | 145 | tools/objtool/objtool ${objtoolcmd} ${objtoolopt} ${1} |
Peter Zijlstra | 6804c1a | 2020-03-18 13:33:54 +0100 | [diff] [blame] | 146 | fi |
| 147 | } |
| 148 | |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 149 | # Link of vmlinux |
Andrii Nakryiko | 341dfcf | 2019-08-12 11:39:47 -0700 | [diff] [blame] | 150 | # ${1} - output file |
Andrii Nakryiko | 618916a | 2019-09-05 10:59:38 -0700 | [diff] [blame] | 151 | # ${2}, ${3}, ... - optional extra .o files |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 152 | vmlinux_link() |
| 153 | { |
| 154 | local lds="${objtree}/${KBUILD_LDS}" |
Andrii Nakryiko | 618916a | 2019-09-05 10:59:38 -0700 | [diff] [blame] | 155 | local output=${1} |
Stephen Rothwell | a5967db | 2016-08-24 22:29:19 +1000 | [diff] [blame] | 156 | local objects |
Kees Cook | af73d78 | 2020-03-03 18:18:34 -0800 | [diff] [blame] | 157 | local strip_debug |
Rasmus Villemoes | 5cc1247 | 2021-03-05 10:27:07 +0100 | [diff] [blame^] | 158 | local map_option |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 159 | |
Linus Torvalds | d7b0827 | 2019-09-20 08:36:47 -0700 | [diff] [blame] | 160 | info LD ${output} |
| 161 | |
Andrii Nakryiko | 618916a | 2019-09-05 10:59:38 -0700 | [diff] [blame] | 162 | # skip output file argument |
| 163 | shift |
| 164 | |
Kees Cook | af73d78 | 2020-03-03 18:18:34 -0800 | [diff] [blame] | 165 | # The kallsyms linking does not need debug symbols included. |
| 166 | if [ "$output" != "${output#.tmp_vmlinux.kallsyms}" ] ; then |
| 167 | strip_debug=-Wl,--strip-debug |
| 168 | fi |
| 169 | |
Rasmus Villemoes | 5cc1247 | 2021-03-05 10:27:07 +0100 | [diff] [blame^] | 170 | if [ -n "${CONFIG_VMLINUX_MAP}" ]; then |
| 171 | map_option="-Map=${output}.map" |
| 172 | fi |
| 173 | |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 174 | if [ "${SRCARCH}" != "um" ]; then |
Sami Tolvanen | dc5723b | 2020-12-11 10:46:19 -0800 | [diff] [blame] | 175 | if [ -n "${CONFIG_LTO_CLANG}" ]; then |
| 176 | # Use vmlinux.o instead of performing the slow LTO |
| 177 | # link again. |
| 178 | objects="--whole-archive \ |
| 179 | vmlinux.o \ |
| 180 | --no-whole-archive \ |
| 181 | ${@}" |
| 182 | else |
| 183 | objects="--whole-archive \ |
| 184 | ${KBUILD_VMLINUX_OBJS} \ |
| 185 | --no-whole-archive \ |
| 186 | --start-group \ |
| 187 | ${KBUILD_VMLINUX_LIBS} \ |
| 188 | --end-group \ |
| 189 | ${@}" |
| 190 | fi |
Stephen Rothwell | a5967db | 2016-08-24 22:29:19 +1000 | [diff] [blame] | 191 | |
Andrii Nakryiko | 618916a | 2019-09-05 10:59:38 -0700 | [diff] [blame] | 192 | ${LD} ${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux} \ |
Kees Cook | af73d78 | 2020-03-03 18:18:34 -0800 | [diff] [blame] | 193 | ${strip_debug#-Wl,} \ |
Andrii Nakryiko | 618916a | 2019-09-05 10:59:38 -0700 | [diff] [blame] | 194 | -o ${output} \ |
Rasmus Villemoes | 5cc1247 | 2021-03-05 10:27:07 +0100 | [diff] [blame^] | 195 | ${map_option} \ |
Stephen Rothwell | a5967db | 2016-08-24 22:29:19 +1000 | [diff] [blame] | 196 | -T ${lds} ${objects} |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 197 | else |
Nicholas Piggin | 6358d6e | 2018-02-11 00:25:03 +1000 | [diff] [blame] | 198 | objects="-Wl,--whole-archive \ |
Masahiro Yamada | d151e97 | 2019-01-17 09:10:04 +0900 | [diff] [blame] | 199 | ${KBUILD_VMLINUX_OBJS} \ |
Nicholas Piggin | 6358d6e | 2018-02-11 00:25:03 +1000 | [diff] [blame] | 200 | -Wl,--no-whole-archive \ |
| 201 | -Wl,--start-group \ |
| 202 | ${KBUILD_VMLINUX_LIBS} \ |
| 203 | -Wl,--end-group \ |
Andrii Nakryiko | 618916a | 2019-09-05 10:59:38 -0700 | [diff] [blame] | 204 | ${@}" |
Stephen Rothwell | a5967db | 2016-08-24 22:29:19 +1000 | [diff] [blame] | 205 | |
Andrii Nakryiko | 618916a | 2019-09-05 10:59:38 -0700 | [diff] [blame] | 206 | ${CC} ${CFLAGS_vmlinux} \ |
Kees Cook | af73d78 | 2020-03-03 18:18:34 -0800 | [diff] [blame] | 207 | ${strip_debug} \ |
Andrii Nakryiko | 618916a | 2019-09-05 10:59:38 -0700 | [diff] [blame] | 208 | -o ${output} \ |
Rasmus Villemoes | 5cc1247 | 2021-03-05 10:27:07 +0100 | [diff] [blame^] | 209 | ${map_option:+-Wl,${map_option}} \ |
Nicholas Piggin | 6358d6e | 2018-02-11 00:25:03 +1000 | [diff] [blame] | 210 | -Wl,-T,${lds} \ |
| 211 | ${objects} \ |
Stephen Rothwell | a5967db | 2016-08-24 22:29:19 +1000 | [diff] [blame] | 212 | -lutil -lrt -lpthread |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 213 | rm -f linux |
| 214 | fi |
| 215 | } |
| 216 | |
Andrii Nakryiko | e83b9f5 | 2019-04-02 09:49:50 -0700 | [diff] [blame] | 217 | # generate .BTF typeinfo from DWARF debuginfo |
Andrii Nakryiko | 341dfcf | 2019-08-12 11:39:47 -0700 | [diff] [blame] | 218 | # ${1} - vmlinux image |
| 219 | # ${2} - file to dump raw BTF data into |
Andrii Nakryiko | e83b9f5 | 2019-04-02 09:49:50 -0700 | [diff] [blame] | 220 | gen_btf() |
| 221 | { |
Andrii Nakryiko | 341dfcf | 2019-08-12 11:39:47 -0700 | [diff] [blame] | 222 | local pahole_ver |
Andrii Nakryiko | e83b9f5 | 2019-04-02 09:49:50 -0700 | [diff] [blame] | 223 | |
Andrii Nakryiko | 581b31c | 2019-05-05 17:10:33 -0700 | [diff] [blame] | 224 | if ! [ -x "$(command -v ${PAHOLE})" ]; then |
Chris Down | 2a67a6c | 2020-01-22 00:01:10 +0000 | [diff] [blame] | 225 | echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available" |
Andrii Nakryiko | 341dfcf | 2019-08-12 11:39:47 -0700 | [diff] [blame] | 226 | return 1 |
Andrii Nakryiko | 581b31c | 2019-05-05 17:10:33 -0700 | [diff] [blame] | 227 | fi |
| 228 | |
Andrii Nakryiko | e83b9f5 | 2019-04-02 09:49:50 -0700 | [diff] [blame] | 229 | pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/') |
Lorenz Bauer | 21a85bd | 2020-06-08 10:42:57 +0100 | [diff] [blame] | 230 | if [ "${pahole_ver}" -lt "116" ]; then |
| 231 | echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.16" |
Andrii Nakryiko | 341dfcf | 2019-08-12 11:39:47 -0700 | [diff] [blame] | 232 | return 1 |
Andrii Nakryiko | e83b9f5 | 2019-04-02 09:49:50 -0700 | [diff] [blame] | 233 | fi |
| 234 | |
Andrii Nakryiko | 341dfcf | 2019-08-12 11:39:47 -0700 | [diff] [blame] | 235 | vmlinux_link ${1} |
Kees Cook | af73d78 | 2020-03-03 18:18:34 -0800 | [diff] [blame] | 236 | |
| 237 | info "BTF" ${2} |
Andrii Nakryiko | e83b9f5 | 2019-04-02 09:49:50 -0700 | [diff] [blame] | 238 | LLVM_OBJCOPY=${OBJCOPY} ${PAHOLE} -J ${1} |
Andrii Nakryiko | 341dfcf | 2019-08-12 11:39:47 -0700 | [diff] [blame] | 239 | |
Fangrui Song | 90ceddc | 2020-03-18 15:27:46 -0700 | [diff] [blame] | 240 | # Create ${2} which contains just .BTF section but no symbols. Add |
| 241 | # SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all |
| 242 | # deletes all symbols including __start_BTF and __stop_BTF, which will |
| 243 | # be redefined in the linker script. Add 2>/dev/null to suppress GNU |
| 244 | # objcopy warnings: "empty loadable segment detected at ..." |
| 245 | ${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \ |
| 246 | --strip-all ${1} ${2} 2>/dev/null |
| 247 | # Change e_type to ET_REL so that it can be used to link final vmlinux. |
| 248 | # Unlike GNU ld, lld does not allow an ET_EXEC input. |
| 249 | printf '\1' | dd of=${2} conv=notrunc bs=1 seek=16 status=none |
Andrii Nakryiko | e83b9f5 | 2019-04-02 09:49:50 -0700 | [diff] [blame] | 250 | } |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 251 | |
Masahiro Yamada | 08beb66 | 2020-09-25 00:45:46 +0900 | [diff] [blame] | 252 | # Create ${2} .S file with all symbols from the ${1} object file |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 253 | kallsyms() |
| 254 | { |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 255 | local kallsymopt; |
| 256 | |
| 257 | if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then |
James Hogan | 6895f97 | 2012-09-06 22:11:25 +0100 | [diff] [blame] | 258 | kallsymopt="${kallsymopt} --all-symbols" |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 259 | fi |
| 260 | |
Ard Biesheuvel | 4d5d566 | 2016-03-15 14:58:12 -0700 | [diff] [blame] | 261 | if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then |
Rusty Russell | c6bda7c | 2014-03-17 14:05:46 +1030 | [diff] [blame] | 262 | kallsymopt="${kallsymopt} --absolute-percpu" |
| 263 | fi |
| 264 | |
Ard Biesheuvel | 2213e9a | 2016-03-15 14:58:19 -0700 | [diff] [blame] | 265 | if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then |
| 266 | kallsymopt="${kallsymopt} --base-relative" |
| 267 | fi |
| 268 | |
Masahiro Yamada | 08beb66 | 2020-09-25 00:45:46 +0900 | [diff] [blame] | 269 | info KSYMS ${2} |
| 270 | ${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${2} |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 271 | } |
| 272 | |
Kees Cook | 8959e39 | 2019-08-13 08:15:32 -0700 | [diff] [blame] | 273 | # Perform one step in kallsyms generation, including temporary linking of |
| 274 | # vmlinux. |
| 275 | kallsyms_step() |
| 276 | { |
| 277 | kallsymso_prev=${kallsymso} |
Kees Cook | af73d78 | 2020-03-03 18:18:34 -0800 | [diff] [blame] | 278 | kallsyms_vmlinux=.tmp_vmlinux.kallsyms${1} |
| 279 | kallsymso=${kallsyms_vmlinux}.o |
Masahiro Yamada | 08beb66 | 2020-09-25 00:45:46 +0900 | [diff] [blame] | 280 | kallsyms_S=${kallsyms_vmlinux}.S |
Kees Cook | 8959e39 | 2019-08-13 08:15:32 -0700 | [diff] [blame] | 281 | |
Linus Torvalds | d7b0827 | 2019-09-20 08:36:47 -0700 | [diff] [blame] | 282 | vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o} |
Masahiro Yamada | 08beb66 | 2020-09-25 00:45:46 +0900 | [diff] [blame] | 283 | kallsyms ${kallsyms_vmlinux} ${kallsyms_S} |
| 284 | |
| 285 | info AS ${kallsyms_S} |
| 286 | ${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS} \ |
| 287 | ${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \ |
| 288 | -c -o ${kallsymso} ${kallsyms_S} |
Kees Cook | 8959e39 | 2019-08-13 08:15:32 -0700 | [diff] [blame] | 289 | } |
| 290 | |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 291 | # Create map file with all symbols from ${1} |
| 292 | # See mksymap for additional details |
| 293 | mksysmap() |
| 294 | { |
| 295 | ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2} |
| 296 | } |
| 297 | |
Shile Zhang | 1091670 | 2019-12-04 08:46:31 +0800 | [diff] [blame] | 298 | sorttable() |
Linus Torvalds | 1347a2ce | 2012-05-28 10:32:28 -0700 | [diff] [blame] | 299 | { |
Shile Zhang | 1091670 | 2019-12-04 08:46:31 +0800 | [diff] [blame] | 300 | ${objtree}/scripts/sorttable ${1} |
Linus Torvalds | 1347a2ce | 2012-05-28 10:32:28 -0700 | [diff] [blame] | 301 | } |
| 302 | |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 303 | # Delete output files in case of error |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 304 | cleanup() |
| 305 | { |
Andrii Nakryiko | 341dfcf | 2019-08-12 11:39:47 -0700 | [diff] [blame] | 306 | rm -f .btf.* |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 307 | rm -f .tmp_System.map |
Sami Tolvanen | a8cccdd | 2020-12-11 10:46:24 -0800 | [diff] [blame] | 308 | rm -f .tmp_initcalls.lds |
Sami Tolvanen | 38e8918 | 2020-12-11 10:46:20 -0800 | [diff] [blame] | 309 | rm -f .tmp_symversions.lds |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 310 | rm -f .tmp_vmlinux* |
| 311 | rm -f System.map |
| 312 | rm -f vmlinux |
Rasmus Villemoes | 5cc1247 | 2021-03-05 10:27:07 +0100 | [diff] [blame^] | 313 | rm -f vmlinux.map |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 314 | rm -f vmlinux.o |
| 315 | } |
| 316 | |
Sylvain BERTRAND | ab160db | 2015-05-07 00:36:04 +0000 | [diff] [blame] | 317 | on_exit() |
| 318 | { |
| 319 | if [ $? -ne 0 ]; then |
| 320 | cleanup |
| 321 | fi |
| 322 | } |
| 323 | trap on_exit EXIT |
| 324 | |
| 325 | on_signals() |
| 326 | { |
| 327 | exit 1 |
| 328 | } |
| 329 | trap on_signals HUP INT QUIT TERM |
| 330 | |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 331 | # Use "make V=1" to debug this script |
| 332 | case "${KBUILD_VERBOSE}" in |
| 333 | *1*) |
| 334 | set -x |
| 335 | ;; |
| 336 | esac |
| 337 | |
| 338 | if [ "$1" = "clean" ]; then |
| 339 | cleanup |
| 340 | exit 0 |
| 341 | fi |
| 342 | |
| 343 | # We need access to CONFIG_ symbols |
Masahiro Yamada | 94cf8ac | 2019-03-08 14:49:10 +0900 | [diff] [blame] | 344 | . include/config/auto.conf |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 345 | |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 346 | # Update version |
| 347 | info GEN .version |
Masahiro Yamada | 278ae60 | 2017-09-22 14:31:13 +0900 | [diff] [blame] | 348 | if [ -r .version ]; then |
| 349 | VERSION=$(expr 0$(cat .version) + 1) |
| 350 | echo $VERSION > .version |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 351 | else |
Masahiro Yamada | 278ae60 | 2017-09-22 14:31:13 +0900 | [diff] [blame] | 352 | rm -f .version |
| 353 | echo 1 > .version |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 354 | fi; |
| 355 | |
| 356 | # final build of init/ |
Masahiro Yamada | 083bc0e | 2020-02-11 05:06:34 +0900 | [diff] [blame] | 357 | ${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init need-builtin=1 |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 358 | |
Nicholas Piggin | abac4c8 | 2016-11-24 03:41:43 +1100 | [diff] [blame] | 359 | #link vmlinux.o |
Nicholas Piggin | abac4c8 | 2016-11-24 03:41:43 +1100 | [diff] [blame] | 360 | modpost_link vmlinux.o |
Peter Zijlstra | 6804c1a | 2020-03-18 13:33:54 +0100 | [diff] [blame] | 361 | objtool_link vmlinux.o |
Nicholas Piggin | abac4c8 | 2016-11-24 03:41:43 +1100 | [diff] [blame] | 362 | |
| 363 | # modpost vmlinux.o to check for section mismatches |
Masahiro Yamada | a721588 | 2019-07-31 00:59:02 +0900 | [diff] [blame] | 364 | ${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1 |
Nicholas Piggin | abac4c8 | 2016-11-24 03:41:43 +1100 | [diff] [blame] | 365 | |
Alexey Gladkov | 898490c | 2019-04-29 18:11:14 +0200 | [diff] [blame] | 366 | info MODINFO modules.builtin.modinfo |
| 367 | ${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo |
Masahiro Yamada | 8b41fc4 | 2019-12-19 17:33:29 +0900 | [diff] [blame] | 368 | info GEN modules.builtin |
| 369 | # The second line aids cases where multiple modules share the same object. |
| 370 | tr '\0' '\n' < modules.builtin.modinfo | sed -n 's/^[[:alnum:]:_]*\.file=//p' | |
| 371 | tr ' ' '\n' | uniq | sed -e 's:^:kernel/:' -e 's/$/.ko/' > modules.builtin |
Alexey Gladkov | 898490c | 2019-04-29 18:11:14 +0200 | [diff] [blame] | 372 | |
Andrii Nakryiko | 7fd7856 | 2019-08-13 11:54:42 -0700 | [diff] [blame] | 373 | btf_vmlinux_bin_o="" |
Andrii Nakryiko | 341dfcf | 2019-08-12 11:39:47 -0700 | [diff] [blame] | 374 | if [ -n "${CONFIG_DEBUG_INFO_BTF}" ]; then |
Kees Cook | af73d78 | 2020-03-03 18:18:34 -0800 | [diff] [blame] | 375 | btf_vmlinux_bin_o=.btf.vmlinux.bin.o |
| 376 | if ! gen_btf .tmp_vmlinux.btf $btf_vmlinux_bin_o ; then |
Stanislav Fomichev | da5fb18 | 2019-11-27 08:14:10 -0800 | [diff] [blame] | 377 | echo >&2 "Failed to generate BTF for vmlinux" |
| 378 | echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF" |
| 379 | exit 1 |
Andrii Nakryiko | 341dfcf | 2019-08-12 11:39:47 -0700 | [diff] [blame] | 380 | fi |
| 381 | fi |
| 382 | |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 383 | kallsymso="" |
Kees Cook | 8959e39 | 2019-08-13 08:15:32 -0700 | [diff] [blame] | 384 | kallsymso_prev="" |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 385 | kallsyms_vmlinux="" |
| 386 | if [ -n "${CONFIG_KALLSYMS}" ]; then |
| 387 | |
| 388 | # kallsyms support |
| 389 | # Generate section listing all symbols and add it into vmlinux |
| 390 | # It's a three step process: |
| 391 | # 1) Link .tmp_vmlinux1 so it has all symbols and sections, |
| 392 | # but __kallsyms is empty. |
| 393 | # Running kallsyms on that gives us .tmp_kallsyms1.o with |
| 394 | # the right size |
| 395 | # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of |
| 396 | # the right size, but due to the added section, some |
| 397 | # addresses have shifted. |
| 398 | # From here, we generate a correct .tmp_kallsyms2.o |
Nicholas Piggin | 7e2b37c | 2016-11-24 03:41:37 +1100 | [diff] [blame] | 399 | # 3) That link may have expanded the kernel image enough that |
| 400 | # more linker branch stubs / trampolines had to be added, which |
| 401 | # introduces new names, which further expands kallsyms. Do another |
| 402 | # pass if that is the case. In theory it's possible this results |
| 403 | # in even more stubs, but unlikely. |
| 404 | # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around |
| 405 | # other bugs. |
| 406 | # 4) The correct ${kallsymso} is linked into the final vmlinux. |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 407 | # |
| 408 | # a) Verify that the System.map from vmlinux matches the map from |
| 409 | # ${kallsymso}. |
| 410 | |
Kees Cook | 8959e39 | 2019-08-13 08:15:32 -0700 | [diff] [blame] | 411 | kallsyms_step 1 |
| 412 | kallsyms_step 2 |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 413 | |
Nicholas Piggin | 7e2b37c | 2016-11-24 03:41:37 +1100 | [diff] [blame] | 414 | # step 3 |
Kees Cook | 8959e39 | 2019-08-13 08:15:32 -0700 | [diff] [blame] | 415 | size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev}) |
| 416 | size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso}) |
Nicholas Piggin | 7e2b37c | 2016-11-24 03:41:37 +1100 | [diff] [blame] | 417 | |
| 418 | if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then |
Kees Cook | 8959e39 | 2019-08-13 08:15:32 -0700 | [diff] [blame] | 419 | kallsyms_step 3 |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 420 | fi |
| 421 | fi |
| 422 | |
Linus Torvalds | d7b0827 | 2019-09-20 08:36:47 -0700 | [diff] [blame] | 423 | vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o} |
Andrii Nakryiko | e83b9f5 | 2019-04-02 09:49:50 -0700 | [diff] [blame] | 424 | |
Jiri Olsa | c9a0f3b | 2020-07-11 23:53:24 +0200 | [diff] [blame] | 425 | # fill in BTF IDs |
Jiri Olsa | 017dab3 | 2020-09-23 20:57:34 +0200 | [diff] [blame] | 426 | if [ -n "${CONFIG_DEBUG_INFO_BTF}" -a -n "${CONFIG_BPF}" ]; then |
| 427 | info BTFIDS vmlinux |
| 428 | ${RESOLVE_BTFIDS} vmlinux |
Jiri Olsa | c9a0f3b | 2020-07-11 23:53:24 +0200 | [diff] [blame] | 429 | fi |
| 430 | |
Shile Zhang | 1091670 | 2019-12-04 08:46:31 +0800 | [diff] [blame] | 431 | if [ -n "${CONFIG_BUILDTIME_TABLE_SORT}" ]; then |
| 432 | info SORTTAB vmlinux |
Shile Zhang | f14bf6a | 2019-12-04 08:46:33 +0800 | [diff] [blame] | 433 | if ! sorttable vmlinux; then |
| 434 | echo >&2 Failed to sort kernel tables |
| 435 | exit 1 |
| 436 | fi |
Linus Torvalds | 1347a2ce | 2012-05-28 10:32:28 -0700 | [diff] [blame] | 437 | fi |
| 438 | |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 439 | info SYSMAP System.map |
| 440 | mksysmap vmlinux System.map |
| 441 | |
| 442 | # step a (see comment above) |
| 443 | if [ -n "${CONFIG_KALLSYMS}" ]; then |
| 444 | mksysmap ${kallsyms_vmlinux} .tmp_System.map |
| 445 | |
| 446 | if ! cmp -s System.map .tmp_System.map; then |
Michal Marek | 5369f55 | 2012-07-07 23:04:40 +0200 | [diff] [blame] | 447 | echo >&2 Inconsistent kallsyms data |
Michal Marek | 367e43c | 2012-08-10 11:55:11 +0200 | [diff] [blame] | 448 | echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround |
Sam Ravnborg | 1f2bfbd | 2012-05-05 10:18:41 +0200 | [diff] [blame] | 449 | exit 1 |
| 450 | fi |
| 451 | fi |